note
	description: "Main window for this application"
	author: "Generated by the New Vision2 Application Wizard."
	date: "$Date: 2013/12/10 15:41:12 $"
	revision: "1.0.0"

class
	MAIN_WINDOW

inherit

	EV_TITLED_WINDOW
		redefine
			initialize,
			is_in_default_state
		end

create
	default_create

feature {NONE} -- Initialization

	initialize
			-- Build the interface for this window.
		do
			Precursor {EV_TITLED_WINDOW}

				-- Execute `request_close_window' when the user clicks
				-- on the cross in the title bar.
			close_request_actions.extend (agent request_close_window)

				-- Set the title of the window.
			set_title (Window_title)

				-- Set the initial size of the window.
			set_size (Window_width, Window_height)

				-- Set the icon.
			create Window_icon.make_with_size (20, 20)
			Window_icon.set_with_named_file ("Images/tree.png")
			set_icon_pixmap (Window_icon)

				-- Disable user resize for this application.
			disable_user_resize
		end

	is_in_default_state: BOOLEAN
			-- Is the window in its default state?
			-- (as stated in `initialize')
		do
			Result := (width = Window_width) and then (height = Window_height) and then (title.is_equal (Window_title))
		end

feature {NONE} -- Implementation, Close event

	request_close_window
			-- Process user request to close the window.
		local
			question_dialog: EV_CONFIRMATION_DIALOG
		do
			create question_dialog.make_with_text ("You are about to close the forest fire application.%NClick OK to proceed.")
			question_dialog.set_width (question_dialog.width + 20)
			question_dialog.set_height (question_dialog.height + 20)
			question_dialog.show_modal_to_window (Current)
			if question_dialog.selected_button ~ (create {EV_DIALOG_CONSTANTS}).ev_ok then
					-- Destroy the window.
				destroy

					-- End the application.
				if attached (create {EV_ENVIRONMENT}).application as a then
					a.destroy
				end
			end
		end

feature {NONE} -- Implementation / Constants

	Window_title: STRING = "Forest Fire"
			-- Title of the window.

	Window_width: INTEGER
			-- Initial width for this window.
		once
			result := {FOREST_FIRE}.Width * {FOREST_RENDERER}.Tile_size + 10 -- The +10 is for the border (only windows, remove if using linux).
		end

	Window_height: INTEGER
			-- Initial height for this window.
		once
			result := {FOREST_FIRE}.Height * {FOREST_RENDERER}.Tile_size + 10 -- The +10 is for the border (only windows, remove if using linux).
		end

	Window_icon: EV_PIXMAP
			-- the icon for the application

end
